use serde::{
    de::{DeserializeOwned, IntoDeserializer},
    Deserializer,
};

use super::Val;

pub fn from_val<T: DeserializeOwned>(
    value: Val,
) -> Result<T, <Val as Deserializer<'static>>::Error> {
    T::deserialize(value.into_deserializer())
}

pub mod deserializer;
pub mod serialize;
